Scriptname MCSMagicEffectCallScript extends activemagiceffect  

GlobalVariable Property MCSGlobalWaitFlag  Auto  
GlobalVariable Property MCSGlobalWaitFlagQuest  Auto  
ReferenceAlias[] Property MCSAliasActor  Auto  ;0͋󔒂ŁAԍ킹
ObjectReference[] Property MCSMarkerActor  Auto  ;0͋󔒂ŁAԍ킹
ObjectReference Property MCSObjectAIFollowRef  Auto  
Message Property MCSMessageCallSneak  Auto  
Faction Property MCSFactionFollow  Auto  
Faction Property MCSFactionStay  Auto  
Int MCSEntryNumber
Int MCSButtonCall
Actor MCSActor

Event OnEffectStart(Actor akTarget, Actor akCaster)

 If MCSGlobalWaitFlag.GetValueInt() == 1 ;If Busy
  Debug.Notification("Wait a Moment, and Retry.")
 Else

  MCSGlobalWaitFlag.SetValueInt(1) ;Tell Busy
  While MCSGlobalWaitFlagQuest.GetValueInt() == 1
  EndWhile
  MCSButtonCall = 0
  If Game.GetPlayer().IsSneaking() == 1
   MCSButtonCall = MCSMessageCallSneak.Show() ;IvV\

   If MCSButtonCall == 1 ;Make Companions Staying Here Follow
    MCSEntryNumber = 1
    While MCSEntryNumber < 99
     MCSActor = MCSAliasActor[MCSEntryNumber].GetActorReference()
     If MCSActor != None
      If MCSActor.IsInFaction(MCSFactionStay) == 1 && MCSActor.GetDistance(Game.GetPlayer()) < 2000
       MCSMarkerActor[MCSEntryNumber].MoveTo(MCSObjectAIFollowRef)
       MCSActor.RemoveFromFaction(MCSFactionStay)
       MCSActor.AddToFaction(MCSFactionFollow)
       MCSActor.SetPlayerTeammate()
       MCSActor.EvaluatePackage()
      EndIf
     EndIf
     MCSEntryNumber += 1
    EndWhile

   ElseIf MCSButtonCall == 2 ;Make Followers Stay Here
    MCSEntryNumber = 1
    While MCSEntryNumber < 99
     MCSActor = MCSAliasActor[MCSEntryNumber].GetActorReference()
     If MCSActor != None
      If MCSActor.IsInFaction(MCSFactionFollow) == 1
       MCSMarkerActor[MCSEntryNumber].MoveTo(MCSActor)
       MCSActor.RemoveFromFaction(MCSFactionFollow)
       MCSActor.AddToFaction(MCSFactionStay)
       MCSActor.SetPlayerTeammate(False)
       MCSActor.EvaluatePackage()
      EndIf
     EndIf
     MCSEntryNumber += 1
    EndWhile
   EndIf

  EndIf

  If MCSButtonCall == 0 ;SneakłȂAIvVCallI񂾏ꍇ
   MCSEntryNumber = 1
   While MCSEntryNumber < 99
    MCSActor = MCSAliasActor[MCSEntryNumber].GetActorReference()
    If MCSActor != None
     If MCSActor.IsInFaction(MCSFactionFollow) == 1
      MCSActor.MoveTo(Game.GetPlayer(),afXOffset = Utility.RandomInt()*4 - 200,afYOffset = Utility.RandomInt()*4 - 200)
     EndIf
    EndIf
    MCSEntryNumber += 1
   EndWhile
  EndIf

  MCSGlobalWaitFlag.SetValueInt(0) ;Tell Not Busy

 EndIf

EndEvent